* PACKAGE P2RMAS  !" ŷˤѲ
*
*" 93/10/07             ŷˤPs Ѳ
*"
***********************************************************************
      SUBROUTINE RMMASS        !" ŷˤѲ
     M         ( GDU   , GDV    , GDT   , GDQ    , GDPS  , 
     I           GQRM  , GSUMRM , DELT ,
     C           SIG   , SIGM   , DSIG  )
*
*"  ŷˤPs Ѳ, dot{sigma} θ̤
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       GDU   ( IDIM*JDIM, KMAX )  !"   
      REAL       GDV   ( IDIM*JDIM, KMAX )  !"   
      REAL       GDT   ( IDIM*JDIM, KMAX )  !"   
      REAL       GDPS  ( IDIM*JDIM       )  !" ɽ У
      REAL       GDQ   ( IDIM*JDIM, KMAX )  !" 漾  
*
*   [INPUT] 
      REAL       GQRM   ( IDIM*JDIM, KMAX )  !" ι߿
      REAL       GSUMRM ( IDIM*JDIM, KMAX )  !" ߿ѻ
      REAL       DELT                         !" ʪֹ 2 t
      REAL       SIG   ( KMAX )              !" ҥ٥()
      REAL       SIGM  (KMAX+1)              !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )              !" 
*      REAL       DSIGM (KMAX+1)              !" (Ⱦ)
      REAL       ATF  ( KMAX )              !" ľ֤ηa
      REAL       BTF  ( KMAX )              !" ľ֤ηb
*
*   [INTERNAL PARM] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
*   [INTERNAL WORK] 
      REAL       GDUM   ( IDIM*JDIM, KMAX)  !" Ⱦ
      REAL       GDVM   ( IDIM*JDIM, KMAX)  !" Ⱦ
      REAL       GDTM   ( IDIM*JDIM, KMAX)  !" ١Ⱦ
      REAL       GDQM   ( IDIM*JDIM, KMAX)  !" 漾Ⱦ
      REAL       GSIGD ( IDIM*JDIM, KMAX+1 ) !" һѲ
      REAL       SALPHA ( KMAX )   !" ſ尵μη
      REAL       SBETA  ( KMAX )   !" ſ尵μη
      SAVE OFIRST , ATF , BTF
*
      REAL       AKAPPA
      INTEGER    IJ, K
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' REMOVE MASS(Ps,U,V,T,Q MODIFY) DATE=93/10/05'
         OFIRST = .FALSE.
*
         AKAPPA = RAIR / CP
*
         DO 1100 K = 1, KMAX
            SALPHA( K ) =        ( SIGM( K   )/SIG ( K ) )**AKAPPA - 1.  
            SBETA ( K ) = 1.   - ( SIGM( K+1 )/SIG ( K ) )**AKAPPA
 1100    CONTINUE
*
         DO 1200 K = 2, KMAX
            ATF ( K ) =   SALPHA( K )
     &              / (   1. - ( SIG( K ) / SIG( K-1 ) )**AKAPPA   )
 1200    CONTINUE
*
         DO 1300 K = 1, KMAX-1
            BTF ( K ) =   SBETA ( K )
     &              / (   ( SIG( K ) / SIG( K+1 ) )**AKAPPA - 1.   )
 1300    CONTINUE
      ENDIF
*
*"         < 1. Ⱦ٥(: ϳؤT Ʊˡ) >
*
*
      DO 1400 K = 2, KMAX
         DO 1400 IJ = 1, IDIM*JDIM
            GDUM( IJ,K ) =    ATF ( K )   * GDU ( IJ,K   )
     &                      + BTF ( K-1 ) * GDU ( IJ,K-1 )
            GDVM( IJ,K ) =    ATF ( K )   * GDV ( IJ,K   )
     &                      + BTF ( K-1 ) * GDV ( IJ,K-1 )
            GDTM( IJ,K ) =    ATF ( K )   * GDT ( IJ,K   )
     &                      + BTF ( K-1 ) * GDT ( IJ,K-1 )
            GDQM( IJ,K ) =    ATF ( K )   * GDQ ( IJ,K   )
     &                      + BTF ( K-1 ) * GDQ ( IJ,K-1 )
 1400 CONTINUE
*
*"         < 2. ұľή >
*
      DO 2100 K=2, KMAX
         DO 2100 IJ = 1, IDIM*JDIM
            GSIGD ( IJ,K ) =  SIGM( K )*GSUMRM( IJ,1)
     &                      - GSUMRM( IJ,K )
 2100 CONTINUE
*
      DO 2200  IJ = 1, IDIM*JDIM
         GSIGD( IJ,1 )     = 0.
         GSIGD( IJ,KMAX+1) = 0.
 2200 CONTINUE
*
*"         < 3. Ps Ѳ: Pa ñ̤Ѵ >
*
      DO 3000 IJ = 1, IDIM*JDIM
c          write(6,*) log(gdps(ij)*100),gsumrm(ij,1)*delt
         GDPS ( IJ ) = EXP( LOG(GDPS (IJ )*100 ) 
     &                     - GSUMRM ( IJ,1 ) *DELT )*0.01
c          write(6,*) gdps(ij)
 3000 CONTINUE
*
*"         < 4. ľή >
*
      DO 4100 K = 2, KMAX
        DO 4100 IJ = 1, IDIM*JDIM
            GDU ( IJ,K )
     &       =  GDU ( IJ,K )
     &        -  GSIGD ( IJ,K )    / DSIG ( K )
     &            * (    GDUM( IJ,K ) - GDU ( IJ,K   )   )
            GDV ( IJ,K )
     &       =  GDV ( IJ,K )
     &        -  GSIGD ( IJ,K )    / DSIG ( K )
     &            * (    GDVM( IJ,K ) - GDV ( IJ,K   )   )
            GDT ( IJ,K )
     &       =  GDT ( IJ,K )
     &        -  GSIGD ( IJ,K )    / DSIG ( K )
     &            * (    GDTM( IJ,K ) - GDT ( IJ,K   )   )
            GDq ( IJ,K )
     &       =  GDq ( IJ,K )
     &        -  GSIGD ( IJ,K )    / DSIG ( K )
     &            * (    GDQM( IJ,K ) - GDQ ( IJ,K   )   )
 4100 CONTINUE
*
      DO 4200 K = 1, KMAX-1
        DO 4200 IJ = 1, IDIM*JDIM
            GDU ( IJ,K )
     &       =  GDU ( IJ,K )
     &        -  GSIGD ( IJ,K+1 )    / DSIG ( K )
     &            * (    GDU( IJ,K ) - GDUM ( IJ,K+1   )   )
            GDV ( IJ,K )
     &       =  GDV ( IJ,K )
     &        -  GSIGD ( IJ,K+1 )    / DSIG ( K )
     &            * (    GDV( IJ,K ) - GDVM ( IJ,K+1   )   )
            GDT ( IJ,K )
     &       =  GDT ( IJ,K )
     &        -  GSIGD ( IJ,K+1 )    / DSIG ( K )
     &            * (    GDT( IJ,K ) - GDTM ( IJ,K+1   )   )
            GDQ ( IJ,K )
     &       =  GDQ ( IJ,K )
     &        -  GSIGD ( IJ,K+1 )    / DSIG ( K )
     &            * (    GDQ( IJ,K ) - GDQM ( IJ,K+1   )   )
 4200 CONTINUE
*
      RETURN
      END

