* PACKAGE P2ICEM  !" ʪ(2) ɹǥ
*
*" 98/11/19             
*"
***********************************************************************
      SUBROUTINE SEAICE
     M         ( GDHI  , GDTO  , 
     M           GTTG  ,
     I           GDTG  , 
     I           TFLUX , QFLUX , RFLUX , SFLUX ,
     I           DELTM                                   )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸʸ
#endif
*
*   [MODIFY] 
      REAL       GDHI  ( IDIM*JDIM       )   !" ɹθ
      REAL       GDTO  ( IDIM*JDIM       )   !" κز
*   [INPUT] 
      REAL       GDTG  ( IDIM*JDIM )         !" ɽ̲
      REAL       GTTG  ( IDIM*JDIM )         !" ɽѲΨ
      REAL       TFLUX ( IDIM*JDIM, KMAX+1 ) !" ԤΥեå
      REAL       QFLUX ( IDIM*JDIM, KMAX+1 ) !" Υեå
      REAL       RFLUX ( IDIM*JDIM, KMAX+1 ) !" Ĺȥեå
      REAL       SFLUX ( IDIM*JDIM, KMAX+1 ) !" ûȥեå
*
      REAL       DELTM                       !" ǥֹ t
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      REAL       FM                          !" ɹɽز
      REAL       FB                          !" ɹɽز
      REAL       FT                          !" ɹɽز
      REAL       QM                          !" ɹɽز
      REAL       QMALL                       !" ɹɽز
      REAL       NGDHI                       !" ѿ( Hi)
      REAL       NGDTT                       !" ѿ( Tt)

      INTEGER    ITIM
      REAL       DELTICE                     !" ice model t

      COMMON    /COMWRK/
     &           GDTT, GBTG
      REAL       GDTT  ( IDIM*JDIM )         !" ɹɽز
      REAL       GBTG  ( IDIM*JDIM )         !" ƥåɽ̲
*
*   [INTERNAL PARM] 
      REAL       HIMIN                       !" ICE κǾ
      REAL       TB                          !" ICE β
      REAL       TFREZ                       !" ɹ
      REAL       TMELT                       !" melting point
      REAL       ELF                         !"  <-> ɹ Ǯ
      REAL       ELC                         !" <->ɹ Ǯ
      REAL       CW                          !" Ǯ
      REAL       CICE                        !" ICE Ǯ
      REAL       RHOW                        !" ̩
      REAL       RHOI                        !" ICE ̩
      REAL       DMIXL                       !" ؤθ
      REAL       KW                          !" Ǯ͢
      REAL       KICE                        !" ICE Ǯ͢
      REAL       HS6                         !" ʿǮflux
      INTEGER    NSTPIM                      !" ƥå׿
      DATA       HIMIN  /       0.02 /
      DATA       TB     /     271.0  /
      DATA       TFREZ  /     271.0  /
      DATA       TMELT  /     272.9  /
      DATA       ELF    /  330000.0  /
      DATA       ELC    / 2500000.0  /
      DATA       CW     /    4220.0  /
      DATA       CICE   /    2100.0  /
      DATA       RHOW   /    1000.0  /
      DATA       RHOI   /     900.0  /
      DATA       DMIXL  /      50.0  /
      DATA       KW     /     400.0  /
      DATA       KICE   /       2.0  /
      DATA       HS6    /       0.0  /
      DATA       NSTPIM /       100  /
      NAMELIST   /NMICEM/ HIMIN, TB, TFREZ, TMELT,ELF, ELC, CW, CICE, 
     &                    RHOW, RHOI, DMIXL, KW, KICE, HS6, NSTPIM
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         WRITE ( 6,* ) ' ICE MODEL DATE=98/12/17'
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMICEM, END=1190 )
 1190    WRITE  ( JFPAR, NMICEM )
      ENDIF
*
      DELTICE = DELTM / NSTPIM

      DO 1100 IJ = 1, IDIM*JDIM
         GBTG( IJ ) = GDTG( IJ )
 1100 CONTINUE
   
      DO 2000 ITIM = 1, NSTPIM
         DO 2100 IJ = 1, IDIM*JDIM
            IF ( GDHI ( IJ ) .EQ. 0.0 ) THEN
               GDTT( IJ ) = GBTG( IJ ) + GTTG( IJ ) * DELTICE 
c            write (6,*) ij, GDTG(ij), GDTT(ij) 
               IF ( GDTT  ( IJ ) .LE. TFREZ) THEN  !" ǽɹĥ
                  GDHI( IJ ) = HIMIN
                  GDTO( IJ ) = GDTT( IJ ) 
     &                        + HIMIN * RHOI * ELF 
     &                          /(RHOW * CW * DMIXL)
               ELSE                                !" ɹ̵
                  GDHI( IJ ) = 0.0
                  GDTO( IJ ) = GDTT( IJ )
               END IF
               GBTG( IJ ) = GDTT( IJ ) 
            ELSE IF ( GDHI( IJ ) .GE. HIMIN ) THEN !" ɹä
               NGDTT = GBTG( IJ ) 
     &             + 4.0 / ( RHOI*CICE*GDHI( IJ ) )
     &               * ( - TFLUX( IJ,1 ) - QFLUX( IJ,1 ) - RFLUX( IJ,1 )
     &                   - SFLUX( IJ,1 ) 
     &                   - KICE  * ( GBTG( IJ ) - TB )/GDHI( IJ )  )
     &               * DELTICE
c$$$               if (ij .eq. 1) then
c$$$                  write(6,*) ij, GDHI( IJ ), NGDTT
c$$$               end if
               IF ( NGDTT .LT. TMELT) THEN           !" Ѳ
                  QM         = 0.0
                  GDTT( IJ ) = NGDTT
               ELSE                                  !" ɽ̤ͻ
                  QM = - TFLUX( IJ,1 ) - QFLUX( IJ,1 ) - RFLUX( IJ,1 )
     &                   - SFLUX( IJ,1 ) 
     &                - KICE  * ( GBTG( IJ ) - TB )/GDHI( IJ )
     &                - ( RHOI * CICE * GDHI( IJ ) )/4.0 
     &                  * ( TMELT - GBTG( IJ ) )/DELTICE 

                  GDTT( IJ ) = TMELT
               END IF

               FM = - KW*( TB-GDTO( IJ ) ) / ( DMIXL/2.0 )      
               FB = - KICE*( GBTG( IJ ) - TB   ) / GDHI (IJ )
     &              + ( RHOI*CICE*GDHI( IJ ) )/4.0
     &                *( GDTT( IJ ) - GBTG( IJ ) )/DELTICE 

c$$$               if (ij .eq. 1) then
c$$$                  write(6,*) ij, ' NGDTT, QM, FM, FB ', NGDTT, QM, FM, FB
c$$$               end if

               NGDHI = 
     &           GDHI( IJ ) + 
     &         (- QM/( RHOI*ELF ) + QFLUX( IJ,1 )/( RHOI* ( EL+ELF ) )
     &         - FM/( RHOI*ELF ) + FB/( RHOI*ELF ) ) * DELTICE
c"                  ʸǤ ELF+ELC ä, 줬?
c"                  QFLUX ˤäƤΤ ELC ˤ٤?
c               write(6,*) ij, ' To(before)= ', GDTO( IJ )

               IF     ( NGDHI .GE. HIMIN ) THEN !" ɹϤޤ
                  GDTO( IJ ) = GDTO( IJ )
     &             + (HS6 - FM)/( RHOW*CW*DMIXL )
     &               * DELTICE
                  GDHI( IJ ) = NGDHI
c               write(6,*) ij, ' FM/FHOW...', (HS6-FM)/(RHOW*CW*DMIXL)

c               GDTO( IJ ) = TB 
c     &                + ( GDTO( IJ ) - TB )
c     &               * EXP ( 2.0*KW / ( RHOW*CW*DMIXL**2 ) * DELTM )
c"                 ϲɽ
               ELSE IF( NGDHI .LT. HIMIN ) THEN !" ɹͻä
                  QMALL = RHOI * ELF * GDHI( IJ ) / DELTICE
c$$$                  write (6,*) 'ij, ITIM, hi, qmall, to',ij,
c$$$     &                         itim,gdhi(ij),qmall, gdto(ij)
                  GDTO( IJ ) = GDTO( IJ ) 
     &                 + ( - TFLUX( IJ,1 ) - QFLUX( IJ,1 ) 
     &                     - RFLUX( IJ,1 ) - SFLUX( IJ,1 )
     &                     - QMALL )
     &                   /( RHOW*CW*DMIXL )*DELTICE
c                  write (6,*) 'after to', gdto(ij)
c"                  Ȥꤢɹͻ򤷤ƤǤȺؤο
c"                  礤ˤ벹Ѳ̵
                  GDHI( IJ ) = 0.0
                  GDTT( IJ ) = GDTO( IJ ) 
               END IF
               GBTG ( IJ ) = GDTT( IJ ) 
            ELSE                                      !" 
               WRITE (6, *) ' ###Warning### Hi < Hi_{min}; Hi= '
     &                      , GDHI( IJ )
               GDHI( IJ ) = 0.0
               GDTO( IJ ) = GBTG( IJ )
            END IF
 2100    CONTINUE
 2000 CONTINUE    
*
      DO 3100 IJ = 1, IDIM*JDIM
         GTTG( IJ ) = ( GDTT( IJ ) - GDTG( IJ ) )/DELTM
 3100 CONTINUE

      RETURN
      END

