* PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"$BMzNr(B 95/05/02 $B@PEO@5<y(B            
*"$BMzNr(B 95/11/28 $B@PEO@5<y(B            
*"
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*"  u, v $B$N$_$K%U%#%k%?!<$r$+$1$k(B
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDU   ( IDIM*JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B
      REAL       GDV   ( IDIM*JDIM, KMAX )  !" $BFnKLIw(B $B#V(B
*
*   [INPUT]
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 )  !"  ($B%@%_!<(B)
*
*   [INPUT]
      REAL    DELTA
*
*   [INTERNAL PARM]
      REAL    SH                               !" $B%U%#%k%?78?t(B
      REAL    SM                               !" $B%U%#%k%?78?t(B
      DATA    SH / 0.5 /
      DATA    SM / 0.5 /
*
      NAMELIST  /NMZFLT/ SH,SM
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
      REAL       GTUZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#UJQ2=N((B
      REAL       GTVZF   ( IDIM*JDIM, KMAX )   !" $B%U%#%k%?#VJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER PACKAGE(U,V) - DATE=95/11/28'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMZFLT, END=190 )
  190    WRITE  ( JFPAR, NMZFLT )
      ENDIF
*
      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTUZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTVZF, IDIM*JDIM*KMAX )
*
      DO 1200 IJ=1,IDIM*JDIM
            GTUZF(IJ,1) = SM/2.0*(GDU(IJ,2)-GDU(IJ,1))/DELTA
            GTVZF(IJ,1) = SM/2.0*(GDV(IJ,2)-GDV(IJ,1))/DELTA
            DO 1100 K=2, KMAX-1
                  GTUZF(IJ,K)
     &          = SM/2.0*(GDU(IJ,K-1)-2.0*GDU(IJ,K)+GDU(IJ,K+1))
     &            /DELTA
                  GTVZF(IJ,K)
     &          = SM/2.0*(GDV(IJ,K-1)-2.0*GDV(IJ,K)+GDV(IJ,K+1))
     &            /DELTA
 1100       CONTINUE 
            GTUZF(IJ,KMAX)
     &         = SM/2.0*(GDU(IJ,KMAX-1)-GDU(IJ,KMAX))/DELTA
            GTVZF(IJ,KMAX)
     &         = SM/2.0*(GDV(IJ,KMAX-1)-GDV(IJ,KMAX))/DELTA
 1200 CONTINUE 
*
      DO 2100 K=1,KMAX
         DO 2100 IJ = 1, IDIM*JDIM
            GDU(IJ,K) = GDU(IJ,K) + GTUZF(IJ,K)*DELTA
            GDV(IJ,K) = GDV(IJ,K) + GTVZF(IJ,K)*DELTA
 2100 CONTINUE 
*
      RETURN
      END


