* PACKAGE DSETV !" ϳ (ľʬ)
*
*"  ??/??/?? ¸            
*"  95/01/23   TBAR0  NAMELIST 
************************************************************************
      SUBROUTINE DSETV       !" ϳإѡȤå(ľʬ)
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     O           GG    , TMTX  , WHMTX , GCMTX ,
     C           SIG   , SIGM  , DSIG            )
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       SALPHA( KMAX )              !" ſ尵μη
      REAL       SBETA ( KMAX )              !" ſ尵μη
      REAL       SKAPPA( KMAX )              !" ٱľ֤η
      REAL       ATF   ( KMAX )              !" ٱľ֤η
      REAL       BTF   ( KMAX )              !" ٱľ֤η
      REAL       TBAR  ( KMAX )              !" ܲ١٥
      REAL       TBARM ( KMAX )              !" ܲ١Ⱦ
      REAL       GG    ( KMAX )              !" ߥץꥷå
      REAL       TMTX  ( KMAX, KMAX )        !" ߥץꥷå
      REAL       WHMTX ( KMAX, KMAX )        !" ߥץꥷå
      REAL       GCMTX ( KMAX, KMAX )        !" ߥץꥷå
*"       :  ľʬ
*
      REAL       SIG   ( KMAX )              !" ҥ٥()
      REAL       SIGM  ( KMAX+1 )            !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )              !" 
*"       :  ɸʻ
*
*   [INTERNAL PARM] 
      REAL       TBAR0                       !" ܲ
      DATA       TBAR0 / 300.   /
*
      NAMELIST  /NMTBAR/ TBAR0
*
*   [INTERNAL WORK] 
      INTEGER    IFPAR, JFPAR
*
*
      WRITE ( 6,* ) ' DYNAMICS SETTING DATE=95/01/23'
*
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMTBAR, END=190 )
  190 WRITE  ( JFPAR, NMTBAR )
*
*"         < 1. ľʬե >
*
      CALL SETVDF
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     C           SIG   , SIGM  , CP    , RAIR  ,
     I           TBAR0                           )
*
*"         < 2. semi-implicit  >
*
      CALL SETMTX
     O         ( GG    , TMTX  , WHMTX , GCMTX ,
     I           SALPHA, SBETA , SKAPPA,
     I           TBAR  , TBARM,
     C           SIGM  , DSIG  , CP             )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETVDF      !" ľʬե
     O        ( SALPHA, SBETA , SKAPPA,
     O          ATF   , BTF   , TBAR  , TBARM ,
     I          SIG   , SIGM  , CP    , RAIR  ,
     I          TBAR0                            )
*
*"                 Arakawa & Suarez ľʬ Һɸ
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)
#else
#include        "zcdim.F"
#endif
*
*   [OUTPUT] 
      REAL       SALPHA( KMAX )              !" ſ尵μη 
      REAL       SBETA ( KMAX )              !" ſ尵μη 
      REAL       SKAPPA( KMAX )              !" ٱľ֤η
      REAL       ATF   ( KMAX )              !" ٱľ֤η
      REAL       BTF   ( KMAX )              !" ٱľ֤η
      REAL       TBAR  ( KMAX )              !" ܲ١٥
      REAL       TBARM ( KMAX )              !" ܲ١Ⱦ
*
*   [INPUT] 
      REAL       SIG   ( KMAX )              !" ҥ٥()
      REAL       SIGM  ( KMAX+1 )            !" ҥ٥(Ⱦ)
      REAL       CP                          !" 絤갵Ǯ
      REAL       RAIR                        !" 絤
      REAL       TBAR0                       !" ܲ
*
*   [INTERNAL WORK] 
      REAL       AKAPPA                      !" ҡã
      INTEGER    K
*
      AKAPPA = RAIR / CP
*
*"         < 1. ſ尵μ >
*
      CALL HYDROS
     I   ( SIG   , SIGM  )
*
      CALL HYDROQ
     O   ( SALPHA, SBETA )
*
*"         < 2. ٹ >
*
      DO 2100 K = 1, KMAX
         SKAPPA( K ) =  (    SIGM( K   ) * SALPHA( K )
     &                     + SIGM( K+1 ) * SBETA ( K )    )
     &                 /(    SIGM( K   ) - SIGM  ( K+1 )  )
 2100 CONTINUE
*
*"         < 3. ٤ >
*
      DO 3100 K = 2, KMAX
         ATF ( K ) =   SALPHA( K )
     &              / (   1. - ( SIG( K ) / SIG( K-1 ) )**AKAPPA   )
 3100 CONTINUE
*
      DO 3200 K = 1, KMAX-1
         BTF ( K ) =   SBETA ( K )
     &              / (   ( SIG( K ) / SIG( K+1 ) )**AKAPPA - 1.   )
 3200 CONTINUE
*
*"         < 4. ܲپ >
*
      DO 4100 K = 1, KMAX
         TBAR  ( K ) = TBAR0
 4100 CONTINUE
*
      DO 4200 K = 2, KMAX
         TBARM ( K ) =   ATF ( K   ) * TBAR ( K   )
     &                 + BTF ( K-1 ) * TBAR ( K-1 )
 4200 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETMTX          !" semi-implicit Ѥι
     O         ( GG    , TMTX  , WHMTX , GCMTX ,
     I           SALPHA, SBETA , SKAPPA,
     I           TBAR  , TBARM ,
     I           SIGM  , DSIG  , CP             )
*
*"                 Arakawa & Suarez ľʬ Һɸ
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)
#else
#include        "zcdim.F"
#endif
*
*   [OUTPUT] 
      REAL       GG    ( KMAX )              !" ߥץꥷå
      REAL       TMTX  ( KMAX, KMAX )        !" ߥץꥷå
      REAL       WHMTX ( KMAX, KMAX )        !" ߥץꥷå
      REAL       GCMTX ( KMAX, KMAX )        !" ߥץꥷå
*
*   [INPUT] 
      REAL       SALPHA( KMAX )              !" ſ尵μη 
      REAL       SBETA ( KMAX )              !" ſ尵μη 
      REAL       SKAPPA( KMAX )              !" ٱľ֤η
      REAL       TBAR  ( KMAX )              !" ܲ١٥
      REAL       TBARM ( KMAX )              !" ܲ١Ⱦ
      REAL       SIGM  ( KMAX+1 )            !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )              !" 
      REAL       CP                          !" 絤갵Ǯ
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           WW    , SS    ,
     &           QQ    , RR
      REAL       WW    ( KMAX, KMAX )        !" 
      REAL       SS    ( KMAX, KMAX )        !" 
      REAL       QQ    ( KMAX, KMAX )        !" 
      REAL       RR    ( KMAX, KMAX )        !" 
*
      INTEGER    K, L, M
*
*"         < 0.  =  >
*
*"         < 1.  = ãʣ >
*
      DO 1100 K = 1, KMAX
         GG ( K ) = CP * SKAPPA( K ) * TBAR( K )
 1100 CONTINUE
*
*"         < 2.  :  =   >
*
      CALL RESET ( WW, KMAX*KMAX )
*
      DO 2120 K = 1, KMAX
*
         DO 2100 L = 1, K
            WW( K,L ) =             CP * SALPHA( L )
 2100   CONTINUE
*
         DO 2110 L = 1, K-1
            WW( K,L ) = WW( K,L ) + CP * SBETA( L )
 2110    CONTINUE
*
 2120 CONTINUE
*
*"         < 3.   ҡ    >
*
      DO 3120 K = 1, KMAX
*
         DO 3100 L = 1, KMAX
            SS( K,L ) =   SIGM( K ) * DSIG( L )
 3100    CONTINUE
*
         DO 3110 L = K, KMAX
            SS( K,L ) =   SS( K,L ) - DSIG( L )
 3110    CONTINUE
*
 3120 CONTINUE
*
*"         < 4.   ҡ ߣ/ߦ     >
*
      CALL RESET ( QQ, KMAX*KMAX )
*
      DO 4100 K = 1, KMAX
         QQ( K,K   ) = ( TBARM( K ) - TBAR ( K   ) ) / DSIG( K )
 4100 CONTINUE
*
      DO 4110 K = 1, KMAX-1
         QQ( K,K+1 ) = ( TBAR ( K ) - TBARM( K+1 ) ) / DSIG( K )
 4110 CONTINUE
*
*"         < 5. ҡʣԡʢߦ/ߣܣ/ҡ
*"                     >
*
      CALL RESET ( RR, KMAX*KMAX )
*
      DO 5120 K = 1, KMAX
*
         DO 5100 L = K, KMAX
            RR( K,L ) = - SALPHA( K ) / DSIG( K ) * DSIG( L )
     &                    * TBAR( K )
 5100    CONTINUE
*
         DO 5110 L = K+1, KMAX
            RR( K,L ) = RR( K,L )
     &                   - SBETA ( K ) / DSIG( K ) * DSIG( L )
     &                     * TBAR( K )
 5110    CONTINUE
*
 5120 CONTINUE
*
*"         < 6.   >
*
      CALL RESET( TMTX, KMAX*KMAX )
*
      DO 6100 K = 1, KMAX
         DO 6100 L = 1, KMAX
            DO 6100 M = 1, KMAX
               TMTX( K,L ) = TMTX( K,L ) + QQ( K,M ) * SS( M,L )
 6100 CONTINUE
*
*"         < 7.     -  >
*
      DO 7100 K = 1, KMAX
         DO 7100 L = 1, KMAX
            TMTX( K,L ) = TMTX( K,L ) - RR( K,L )
 7100 CONTINUE
*
*"         < 8.   >
*
      CALL RESET ( WHMTX, KMAX*KMAX )
*
      DO 8100 K = 1, KMAX
         DO 8100 L = 1, KMAX
            DO 8100 M = 1, KMAX
               WHMTX( K,L ) = WHMTX( K,L ) + WW( K,M ) * TMTX( M,L )
 8100 CONTINUE
*
*"         < 9.  t  >
*
      DO 9100 K = 1, KMAX
         DO 9100 L = 1, KMAX
               GCMTX( K,L ) = GG( K ) * DSIG( L )
 9100 CONTINUE
*
      RETURN
      END
